Index: /trunk/sources/HeuristicLab.Hive.Client.Console/HiveClientConsole.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Console/HiveClientConsole.Designer.cs	(revision 1009)
+++ /trunk/sources/HeuristicLab.Hive.Client.Console/HiveClientConsole.Designer.cs	(revision 1010)
@@ -62,5 +62,4 @@
       this.lbCs = new System.Windows.Forms.Label();
       this.lbConnectionStatus = new System.Windows.Forms.Label();
-      this.zGJobs = new ZedGraph.ZedGraphControl();
       this.lbConnectionStatusCaption = new System.Windows.Forms.Label();
       this.lbJobsAbortedCaption = new System.Windows.Forms.Label();
@@ -87,4 +86,5 @@
       this.lbServerIPCaption = new System.Windows.Forms.Label();
       this.lbPortCaption = new System.Windows.Forms.Label();
+      this.pbGraph = new System.Windows.Forms.PictureBox();
       this.tcClientConsole.SuspendLayout();
       this.tpConnection.SuspendLayout();
@@ -95,4 +95,5 @@
       this.gbOnlineTime.SuspendLayout();
       this.gbServerConnection.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.pbGraph)).BeginInit();
       this.SuspendLayout();
       // 
@@ -163,4 +164,5 @@
       // gbCommon
       // 
+      this.gbCommon.Controls.Add(this.pbGraph);
       this.gbCommon.Controls.Add(this.lbJobsAborted);
       this.gbCommon.Controls.Add(this.lbJobdone);
@@ -170,5 +172,4 @@
       this.gbCommon.Controls.Add(this.lbCs);
       this.gbCommon.Controls.Add(this.lbConnectionStatus);
-      this.gbCommon.Controls.Add(this.zGJobs);
       this.gbCommon.Controls.Add(this.lbConnectionStatusCaption);
       this.gbCommon.Controls.Add(this.lbJobsAbortedCaption);
@@ -245,20 +246,4 @@
       this.lbConnectionStatus.TabIndex = 16;
       this.lbConnectionStatus.Text = "loading...";
-      // 
-      // zGJobs
-      // 
-      this.zGJobs.BackColor = System.Drawing.SystemColors.Control;
-      this.zGJobs.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
-      this.zGJobs.Location = new System.Drawing.Point(255, 14);
-      this.zGJobs.Name = "zGJobs";
-      this.zGJobs.ScrollGrace = 0;
-      this.zGJobs.ScrollMaxX = 0;
-      this.zGJobs.ScrollMaxY = 0;
-      this.zGJobs.ScrollMaxY2 = 0;
-      this.zGJobs.ScrollMinX = 0;
-      this.zGJobs.ScrollMinY = 0;
-      this.zGJobs.ScrollMinY2 = 0;
-      this.zGJobs.Size = new System.Drawing.Size(149, 111);
-      this.zGJobs.TabIndex = 14;
       // 
       // lbConnectionStatusCaption
@@ -379,4 +364,5 @@
       // gbOnlineTime
       // 
+      this.gbOnlineTime.BackColor = System.Drawing.SystemColors.Control;
       this.gbOnlineTime.Controls.Add(this.label1);
       this.gbOnlineTime.Location = new System.Drawing.Point(9, 117);
@@ -484,8 +470,18 @@
       this.lbPortCaption.Text = "Port:";
       // 
+      // pbGraph
+      // 
+      this.pbGraph.Location = new System.Drawing.Point(292, 19);
+      this.pbGraph.Name = "pbGraph";
+      this.pbGraph.Size = new System.Drawing.Size(112, 108);
+      this.pbGraph.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
+      this.pbGraph.TabIndex = 21;
+      this.pbGraph.TabStop = false;
+      // 
       // HiveClientConsole
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.BackColor = System.Drawing.SystemColors.Control;
       this.ClientSize = new System.Drawing.Size(437, 508);
       this.Controls.Add(this.tcClientConsole);
@@ -505,4 +501,5 @@
       this.gbServerConnection.ResumeLayout(false);
       this.gbServerConnection.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.pbGraph)).EndInit();
       this.ResumeLayout(false);
 
@@ -539,5 +536,4 @@
     private System.Windows.Forms.Button btnDisconnect;
     private System.Windows.Forms.Button btConnect;
-    private ZedGraph.ZedGraphControl zGJobs;
     private System.Windows.Forms.ColumnHeader chId;
     private System.Windows.Forms.ImageList ilEventLog;
@@ -551,4 +547,5 @@
     private System.Windows.Forms.Label lbJobsAborted;
     private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.PictureBox pbGraph;
   }
 }
Index: /trunk/sources/HeuristicLab.Hive.Client.Console/HiveClientConsole.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Client.Console/HiveClientConsole.cs	(revision 1009)
+++ /trunk/sources/HeuristicLab.Hive.Client.Console/HiveClientConsole.cs	(revision 1010)
@@ -134,5 +134,5 @@
         }
 
-        UpdateGraph(zGJobs, sc.JobsDone, sc.JobsAborted);
+        UpdateGraph(sc.JobsDone, sc.JobsAborted);
 
         if (sc.Status == NetworkEnumWcfConnState.Connected) {
@@ -194,8 +194,8 @@
     }
 
-    private void UpdateGraph(ZedGraphControl zgc, int jobsDone, int jobsAborted) {
+    private void UpdateGraph(int jobsDone, int jobsAborted) {
+      ZedGraphControl zgc = new ZedGraphControl();
       GraphPane myPane = zgc.GraphPane;
       myPane.GraphObjList.Clear();
-
 
       myPane.Title.IsVisible = false;  // no title
@@ -205,14 +205,9 @@
       myPane.YAxis.IsVisible = false;  // no y-axis
       myPane.Legend.IsVisible = false; // no legend
-      
+
+      myPane.Fill.Color = Color.FromKnownColor(KnownColor.Control);
+
       myPane.Chart.Fill.Type = FillType.None;
-      myPane.Fill.Type = FillType.None;
-
-      //// Set the titles and axis labels
-      //myPane.Legend.IsVisible = false;
-      //myPane.Title.IsVisible = false;
-      ////myPane.Fill.Type = FillType.None;
-      ////myPane.Fill = new Fill();
-      ////myPane.Fill.Color = Color.Transparent;
+      myPane.Fill.Type = FillType.Solid;
 
       double sum = (double)jobsDone + jobsAborted;
@@ -220,8 +215,10 @@
       double perAborted = (double)jobsAborted / sum * 100;
 
-      myPane.AddPieSlice(perDone, Color.Green, 0.1, "Jobs done");
-      myPane.AddPieSlice(perAborted, Color.Red, 0.1, "Jobs aborted");
+      myPane.AddPieSlice(perDone, Color.Green, 0.1, "");
+      myPane.AddPieSlice(perAborted, Color.Red, 0.1, "");
       
       myPane.AxisChange();
+
+      pbGraph.Image = zgc.GetImage();
     }
 
@@ -246,13 +243,12 @@
         cc.IPAdress = tbIPAdress.Text;
         cc.Port = port;
-        cccc.SetConnection(cc);
+        cccc.SetConnectionAsync(cc);
       } else {
         MessageBox.Show("IP Adress and/or Port Error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
       }
-      
     }
 
     private void btnDisconnect_Click(object sender, EventArgs e) {
-      cccc.Disconnect();
+      cccc.DisconnectAsync();
     }
 