Index: /trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj	(revision 1054)
+++ /trunk/sources/HeuristicLab.Visualization/HeuristicLab.Visualization.csproj	(revision 1055)
@@ -81,4 +81,6 @@
     <Compile Include="CompositeShape.cs" />
     <Compile Include="ChartDataRowsModelDataCollector.cs" />
+    <Compile Include="IMouseEventListener.cs" />
+    <Compile Include="PanListener.cs" />
     <Compile Include="TextShape.cs" />
     <Compile Include="LegendShape.cs" />
@@ -98,5 +100,4 @@
     </Compile>
     <Compile Include="LineShape.cs" />
-    <Compile Include="MouseEventListener.cs" />
     <Compile Include="Offset.cs" />
     <Compile Include="PointD.cs" />
@@ -108,4 +109,5 @@
     <Compile Include="WorldShape.cs" />
     <Compile Include="XAxis.cs" />
+    <Compile Include="ZoomListener.cs" />
   </ItemGroup>
   <ItemGroup>
Index: /trunk/sources/HeuristicLab.Visualization/IMouseEventListener.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/IMouseEventListener.cs	(revision 1055)
+++ /trunk/sources/HeuristicLab.Visualization/IMouseEventListener.cs	(revision 1055)
@@ -0,0 +1,15 @@
+using System.Drawing;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Visualization {
+  public interface IMouseEventListener {
+    void MouseMove(object sender, MouseEventArgs e);
+    void MouseUp(object sender, MouseEventArgs e);
+
+    event MouseEventHandler OnMouseMove;
+    event MouseEventHandler OnMouseUp;
+  }
+
+  public delegate void SetNewClippingAreaHandler(RectangleD newClippingArea);
+  public delegate void DrawRectangleHandler(Rectangle rectangle);
+}
Index: unk/sources/HeuristicLab.Visualization/MouseEventListener.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/MouseEventListener.cs	(revision 1054)
+++ 	(revision )
@@ -1,116 +1,0 @@
-﻿using System.Drawing;
-using System.Windows.Forms;
-
-namespace HeuristicLab.Visualization {
-  public interface IMouseEventListener {
-    void MouseMove(object sender, MouseEventArgs e);
-    void MouseUp(object sender, MouseEventArgs e);
-
-    event MouseEventHandler OnMouseMove;
-    event MouseEventHandler OnMouseUp;
-  }
-
-  public delegate void SetNewClippingAreaHandler(RectangleD newClippingArea);
-
-  public delegate void DrawRectangleHandler(Rectangle rectangle);
-
-  public class PanListener : IMouseEventListener {
-    private readonly Rectangle viewPort;
-    private readonly RectangleD clippingArea;
-    private readonly Point startPoint;
-
-    public PanListener(Rectangle viewPort, RectangleD clippingArea, Point startPoint) {
-      this.viewPort = viewPort;
-      this.clippingArea = clippingArea;
-      this.startPoint = startPoint;
-    }
-
-    #region IMouseEventListener Members
-
-    public event SetNewClippingAreaHandler SetNewClippingArea;
-    public event MouseEventHandler OnMouseMove;
-    public event MouseEventHandler OnMouseUp;
-
-    public void MouseMove(object sender, MouseEventArgs e) {
-      PointD worldStartPoint = Transform.ToWorld(startPoint, viewPort, clippingArea);
-      PointD worldActualPoint = Transform.ToWorld(e.Location, viewPort, clippingArea);
-
-      double xDiff = worldActualPoint.X - worldStartPoint.X;
-      double yDiff = worldActualPoint.Y - worldStartPoint.Y;
-
-      RectangleD newClippingArea = new RectangleD();
-      newClippingArea.X1 = clippingArea.X1 - xDiff;
-      newClippingArea.X2 = clippingArea.X2 - xDiff;
-      newClippingArea.Y1 = clippingArea.Y1 - yDiff;
-      newClippingArea.Y2 = clippingArea.Y2 - yDiff;
-
-      if (SetNewClippingArea != null) {
-        SetNewClippingArea(newClippingArea);
-      }
-
-      if (OnMouseMove != null) {
-        OnMouseMove(sender, e);
-      }
-    }
-
-    public void MouseUp(object sender, MouseEventArgs e) {
-      if (OnMouseUp != null) {
-        OnMouseUp(sender, e);
-      }
-    }
-
-    #endregion
-  }
-
-  public class ZoomListener : IMouseEventListener {
-    private readonly Point startPoint;
-
-    public event DrawRectangleHandler DrawRectangle;
-
-    public ZoomListener(Point startPoint) {
-      this.startPoint = startPoint;
-    }
-
-    #region IMouseEventListener Members
-
-    public event MouseEventHandler OnMouseMove;
-    public event MouseEventHandler OnMouseUp;
-
-    public void MouseMove(object sender, MouseEventArgs e) {
-      Rectangle r = new Rectangle();
-      Point actualPoint = e.Location;
-
-      if (startPoint.X < actualPoint.X) {
-        r.X = startPoint.X;
-        r.Width = actualPoint.X - startPoint.X;
-      } else {
-        r.X = actualPoint.X;
-        r.Width = startPoint.X - actualPoint.X;
-      }
-
-      if (startPoint.Y < actualPoint.Y) {
-        r.Y = startPoint.Y;
-        r.Height = actualPoint.Y - startPoint.Y;
-      } else {
-        r.Y = actualPoint.Y;
-        r.Height = startPoint.Y - actualPoint.Y;
-      }
-
-      if(DrawRectangle != null) {
-        DrawRectangle(r);
-      }
-
-      if (OnMouseMove != null) {
-        OnMouseMove(sender, e);
-      }
-    }
-
-    public void MouseUp(object sender, MouseEventArgs e) {
-      if (OnMouseUp != null) {
-        OnMouseUp(sender, e);
-      }
-    }
-
-    #endregion
-  }
-}
Index: /trunk/sources/HeuristicLab.Visualization/PanListener.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/PanListener.cs	(revision 1055)
+++ /trunk/sources/HeuristicLab.Visualization/PanListener.cs	(revision 1055)
@@ -0,0 +1,52 @@
+using System.Drawing;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Visualization {
+  public class PanListener : IMouseEventListener {
+    private readonly Rectangle viewPort;
+    private readonly RectangleD clippingArea;
+    private readonly Point startPoint;
+
+    public PanListener(Rectangle viewPort, RectangleD clippingArea, Point startPoint) {
+      this.viewPort = viewPort;
+      this.clippingArea = clippingArea;
+      this.startPoint = startPoint;
+    }
+
+    #region IMouseEventListener Members
+
+    public event SetNewClippingAreaHandler SetNewClippingArea;
+    public event MouseEventHandler OnMouseMove;
+    public event MouseEventHandler OnMouseUp;
+
+    public void MouseMove(object sender, MouseEventArgs e) {
+      PointD worldStartPoint = Transform.ToWorld(startPoint, viewPort, clippingArea);
+      PointD worldActualPoint = Transform.ToWorld(e.Location, viewPort, clippingArea);
+
+      double xDiff = worldActualPoint.X - worldStartPoint.X;
+      double yDiff = worldActualPoint.Y - worldStartPoint.Y;
+
+      RectangleD newClippingArea = new RectangleD();
+      newClippingArea.X1 = clippingArea.X1 - xDiff;
+      newClippingArea.X2 = clippingArea.X2 - xDiff;
+      newClippingArea.Y1 = clippingArea.Y1 - yDiff;
+      newClippingArea.Y2 = clippingArea.Y2 - yDiff;
+
+      if (SetNewClippingArea != null) {
+        SetNewClippingArea(newClippingArea);
+      }
+
+      if (OnMouseMove != null) {
+        OnMouseMove(sender, e);
+      }
+    }
+
+    public void MouseUp(object sender, MouseEventArgs e) {
+      if (OnMouseUp != null) {
+        OnMouseUp(sender, e);
+      }
+    }
+
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.Visualization/ZoomListener.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization/ZoomListener.cs	(revision 1055)
+++ /trunk/sources/HeuristicLab.Visualization/ZoomListener.cs	(revision 1055)
@@ -0,0 +1,56 @@
+using System.Drawing;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Visualization {
+  public class ZoomListener : IMouseEventListener {
+    private readonly Point startPoint;
+
+    public event DrawRectangleHandler DrawRectangle;
+
+    public ZoomListener(Point startPoint) {
+      this.startPoint = startPoint;
+    }
+
+    #region IMouseEventListener Members
+
+    public event MouseEventHandler OnMouseMove;
+    public event MouseEventHandler OnMouseUp;
+
+    public void MouseMove(object sender, MouseEventArgs e) {
+      Rectangle r = new Rectangle();
+      Point actualPoint = e.Location;
+
+      if (startPoint.X < actualPoint.X) {
+        r.X = startPoint.X;
+        r.Width = actualPoint.X - startPoint.X;
+      } else {
+        r.X = actualPoint.X;
+        r.Width = startPoint.X - actualPoint.X;
+      }
+
+      if (startPoint.Y < actualPoint.Y) {
+        r.Y = startPoint.Y;
+        r.Height = actualPoint.Y - startPoint.Y;
+      } else {
+        r.Y = actualPoint.Y;
+        r.Height = startPoint.Y - actualPoint.Y;
+      }
+
+      if(DrawRectangle != null) {
+        DrawRectangle(r);
+      }
+
+      if (OnMouseMove != null) {
+        OnMouseMove(sender, e);
+      }
+    }
+
+    public void MouseUp(object sender, MouseEventArgs e) {
+      if (OnMouseUp != null) {
+        OnMouseUp(sender, e);
+      }
+    }
+
+    #endregion
+  }
+}